#ifndef SYNCHTTP_H
#define SYNCHTTP_H

#include <QtNetwork>

class SyncHttp : public QObject {

    Q_OBJECT

public:
    SyncHttp( QObject* parent=0);
    QByteArray getBytes(QUrl url);
    QString get(QUrl url);
    QHttpResponseHeader head(QUrl url);

private slots:
    void requestFinished(int requestId, bool error);
    void readResponseHeader(const QHttpResponseHeader &);

private:
    QHttp *http;
    QBuffer *httpBuffer;
    int httpRequestId;
    bool httpActive;
    bool noHeaders;

};

#endif // SYNCHTTP_H
