#ifndef YOUTUBESEARCH_H
#define YOUTUBESEARCH_H

#include <QtNetwork>
#include "video.h"
#include "synchttp.h"

class YouTubeSearch : public QObject {

    Q_OBJECT

public:
    YouTubeSearch();
    void search(QString query, int max, int skip);
    void abort();
    QList<Video*> getResults();

signals:
    void gotVideo(Video*);
    void finished(int total);

private slots:
    void searchFinished(int requestId, bool error);

private:
    void parseResults(QBuffer *buffer);
    void request(QHttp* http, QUrl url);

    // QHttp makes one request at the time
    // so we just need one buffer and one id
    QHttp *http;
    QBuffer *httpBuffer;
    int httpRequestId;

    QList<Video*> videos;

    SyncHttp *syncHttp;

    bool abortFlag;

};

#endif // YOUTUBESEARCH_H
